//---------------------------------------------------------------------------


#pragma hdrstop

#include "Cor.h"

//---------------------------------------------------------------------------
Cor::Cor(float _valorR, float _valorG, float _valorB)
{
  SetR(_valorR);
  SetG(_valorG);
  SetB(_valorB);
}
//---------------------------------------------------------------------------
Cor::operator=(const Cor& outra)
{
  SetR(outra.valorR);
  SetG(outra.valorG);
  SetB(outra.valorB);
}
//---------------------------------------------------------------------------
Cor::Cor(unsigned int cor)
{
  unsigned int r, g, b;
  r = cor & 0xFF;
  g = (cor >> 8) & 0xFF;
  b = (cor >> 16) & 0xFF;

  SetR(r/255.0);
  SetG(g/255.0);
  SetB(b/255.0);
}
//---------------------------------------------------------------------------
Cor::Cor()
{
  SetR(1.0);
  SetG(1.0);
  SetB(1.0);

}
//---------------------------------------------------------------------------
void Cor::SetR(float valor)
{
  valorR = valor;
  valorRInteiro = valorR * 255;
}
//---------------------------------------------------------------------------
void Cor::SetG(float valor)
{
  valorG = valor;
  valorGInteiro = valorG * 255;
}
//---------------------------------------------------------------------------
void Cor::SetB(float valor)
{
  valorB = valor;
  valorBInteiro = valorB * 255;
}
//---------------------------------------------------------------------------
unsigned char Cor::GetRInteiro()
{
  return valorRInteiro;
}
//---------------------------------------------------------------------------
unsigned char Cor::GetGInteiro()
{
  return valorGInteiro;
}
//---------------------------------------------------------------------------
unsigned char Cor::GetBInteiro()
{
  return valorBInteiro;
}
//---------------------------------------------------------------------------

unsigned int Cor::RBGParaNumero()
{
  unsigned int r, g, b;
  r = 255 * valorR;
  g = 255 * valorG;
  b = 255 * valorB;

  unsigned int resultado = 0;
  resultado = resultado | r;
  resultado = resultado | (g << 8);
  resultado = resultado | (b << 16);

  return resultado;
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
