#ifndef CurvaH
#define CurvaH

#include <vector.h>
#include "ObjetoGrafico.h"
class Ponto;
class Matriz;
class Reta;

enum tipoCurva
{
  BEZIER,
  HERMITE,
  SPLINE
};
//---------------------------------------------------------------------------

class Curva : public ObjetoGrafico
{
  public:
    Curva(string nome, tipoCurva _tipo);
    ~Curva();
    vector<float*>* CoeficientesDaCurva();
    // Retorna as retas desta curva para desenho, as retas so apagadas quando
    // esse mtodo  chamado denovo retornando novas retas
    void SetPontos(vector<Ponto*>* _pontos);
    void AdicionaPonto(Ponto* ponto);
    virtual Ponto* Centro();
    virtual void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao, bool CPP=false);
    virtual void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP);
    int PassoRecomendado(float tamWindow, int tamViewport);
    void SalvaNoStream(ostream &output);
    static Curva* LeDoStream(istream &input, int versao);
    static Matriz* MatrizDaCurva(tipoCurva _tipo);

  private:
    Matriz* matrizDaCurva;
    vector<Ponto*> pontos;
    tipoCurva tipo;
    vector<Reta*>* retasDaCurva; // Usado para o gerenciamento de memria
};

//---------------------------------------------------------------------------
#endif
