//---------------------------------------------------------------------------

#ifndef MatrizH
#define MatrizH
//---------------------------------------------------------------------------
class Matriz {

  public:
    Matriz(int _nrLinhas, int nrColunas);
    ~Matriz();
    int GetNrLinhas();
    int GetNrColunas();
    float GetElemento(int linha, int coluna) const;
    void ColocarElemento(int linha, int coluna, float numero);
    Matriz* GeraTransposta();
    static Matriz* MultiplicaMatriz(Matriz* uma, Matriz* outra);
    static Matriz* CriarMatrizTransformacaoTranslacao(float* translacao);
    static Matriz* CriarMatrizTransformacaoEscalonamento(float* escalonamento);
    static Matriz* CriarMatrizTransformacaoRotacaoX(float anguloGraus);
    static Matriz* CriarMatrizTransformacaoRotacaoY(float anguloGraus);
    static Matriz* CriarMatrizTransformacaoRotacaoZ(float anguloGraus);
    static Matriz* AdicionaTransformacao(Matriz* uma, Matriz* transformacao, bool apaga); // Apaga as duas matrizes e retorna uma nova
    static Matriz* CriarMatrizFwdDiff(int nrPassos);
    void SomaComLinhaAbaixo(); // Linha 0 += Linha1 , Linha1 += Linha2...

  private:
    float* elementos;
    int nrLinhas;
    int nrColunas;
};
#endif
