#pragma hdrstop

#include <Values.h>

#include "ObjetoGrafico.h"
#include "Matriz.h"
#include "Ponto.h"
//---------------------------------------------------------------------------
ObjetoGrafico::ObjetoGrafico(string _nome)
 : handle((unsigned int)this),
   cor(Cor(0,0,0))
{
  nome = _nome;
  animar=false;
}
//---------------------------------------------------------------------------
ObjetoGrafico::~ObjetoGrafico()
{
}
//---------------------------------------------------------------------------
void ObjetoGrafico::setNome(string _nome)
{
  nome = _nome;
}
//---------------------------------------------------------------------------
string ObjetoGrafico::getNome()
{
  return nome;
}
//---------------------------------------------------------------------------
void ObjetoGrafico::SetCor(Cor _cor)
{
  cor = _cor;
}
//---------------------------------------------------------------------------
Cor ObjetoGrafico::GetCor()
{
  return cor;
}
//---------------------------------------------------------------------------
void ObjetoGrafico::SetCor(unsigned int _cor)
{
  cor = Cor(_cor);
}
//---------------------------------------------------------------------------
void ObjetoGrafico::Animar()
{
  animar = !animar;
}
//---------------------------------------------------------------------------
bool ObjetoGrafico::Animado()
{
  return animar;
}
//---------------------------------------------------------------------------
Matriz* ObjetoGrafico::CriarMatrizTransformacoes(float* translacao, float* escalonamento, float* rotacao, Ponto* centro)
{
  float translacao1[3];
  translacao1[0] = - Centro()->GetX();
  translacao1[1] = - Centro()->GetY();
  translacao1[2] = - Centro()->GetZ();
  float translacao2[3];
  translacao2[0] = Centro()->GetX();
  translacao2[1] = Centro()->GetY();
  translacao2[2] = Centro()->GetZ();

  Matriz* transformacao=NULL;
  Matriz* temp;
  if (rotacao || escalonamento) {
    transformacao = Matriz::CriarMatrizTransformacaoTranslacao(translacao1);
    if (rotacao) {
      temp = Matriz::CriarMatrizTransformacaoRotacaoX(rotacao[0]);
      transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
      temp = Matriz::CriarMatrizTransformacaoRotacaoY(rotacao[1]);
      transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
      temp = Matriz::CriarMatrizTransformacaoRotacaoZ(rotacao[2]);
      transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
    }
    if (escalonamento) {
      temp = Matriz::CriarMatrizTransformacaoEscalonamento(escalonamento);
      transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
    }
    temp =  Matriz::CriarMatrizTransformacaoTranslacao(translacao2);
    transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
  }
  if (translacao) {
    temp =  Matriz::CriarMatrizTransformacaoTranslacao(translacao);
    if (transformacao)
      transformacao = Matriz::AdicionaTransformacao(transformacao, temp, true);
    else
      transformacao = temp;
  }
  return transformacao;
}
//---------------------------------------------------------------------------
void ObjetoGrafico::AplicaTransformacaoNoPonto(Ponto* ponto, Matriz* transformacao, bool CPP) {

  Matriz* pontoAnterior = new Matriz(1,4);
  pontoAnterior->ColocarElemento(0,0,ponto->GetX());
  pontoAnterior->ColocarElemento(0,1,ponto->GetY());
  pontoAnterior->ColocarElemento(0,2,ponto->GetZ());
  pontoAnterior->ColocarElemento(0,3,1);

  Matriz* retorno = Matriz::MultiplicaMatriz(pontoAnterior, transformacao);
  if (!CPP) {
    ponto->SetX(retorno->GetElemento(0,0));
    ponto->SetY(retorno->GetElemento(0,1));
    ponto->SetZ(retorno->GetElemento(0,2));
    ponto->SetW(retorno->GetElemento(0,3));
  } else {
    ponto->SetXWindow(retorno->GetElemento(0,0));
    ponto->SetYWindow(retorno->GetElemento(0,1));
    ponto->SetZWindow(retorno->GetElemento(0,2));
    ponto->SetWWindow(retorno->GetElemento(0,3));
  }

  delete retorno;
  delete pontoAnterior;

}
//---------------------------------------------------------------------------
void ObjetoGrafico::SalvaNoStream(ostream &output)
{
  const char* nomeChar = nome.c_str();
  output << nome.size() << " " << nomeChar;
}
//---------------------------------------------------------------------------
string ObjetoGrafico::LeNomeDoStream(istream &input)
{
  int tamanho;
  input >> tamanho;
  if (tamanho>0){
    char* nomeChar = new char[tamanho+2];
    input.read(nomeChar,tamanho+1);
    nomeChar[tamanho+2] = 0;
    return string(nomeChar).substr(1,tamanho);
  } else return "";
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
