//---------------------------------------------------------------------------
#ifndef ObjetoGraficoH
#define ObjetoGraficoH

#include <iostream>
#include <fstream.h>

#include "Cor.h"

using namespace std;

class Matriz;
class Ponto;

enum Eixo {
  EIXO_X,
  EIXO_Y,
  EIXO_Z
};

class ObjetoGrafico {
  public:
    ObjetoGrafico(string _nome);
    virtual ~ObjetoGrafico();
    void setNome(string _nome);
    string getNome();
    void SetCor(Cor _cor);
    void SetCor(unsigned int cor);    
    Cor GetCor();
    virtual Ponto* Centro()=0;
    virtual void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao, bool CPP=false)=0;
    virtual void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP)=0;
    unsigned int GetHandle(){return handle;};
    void SetHandle(unsigned int _handle){handle = _handle;};
    virtual void SalvaNoStream(ostream &output);
    static string LeNomeDoStream(istream &output);
    void Animar();
    bool Animado();

  protected:
    Matriz* CriarMatrizTransformacoes(float* translacao, float* escalonamento, float* rotacao, Ponto* centro);
    void AplicaTransformacaoNoPonto(Ponto* ponto, Matriz* transformacao, bool CPP=false);
    string nome;
    Cor cor;
    unsigned int handle;
    bool animar;

  private:
};

#endif
