//---------------------------------------------------------------------------

#ifndef ObjetoTriangularizadoH
#define ObjetoTriangularizadoH

#include "ObjetoGrafico.h"
#include <vector.h>

class Cor;
class Ponto;
class Triangulo;
class SistemaGrafico;

class ObjetoTriangularizado : public ObjetoGrafico
{
  public:
    ObjetoTriangularizado(
      string nome,
      unsigned int amb_ref_coef,
      unsigned int diff_ref_coef,
      unsigned int spec_ref_coef,
      float shine_coef,
      vector<Triangulo*>* triangulos
    );
    void setAmbRefCoef(Cor* amb_ref_coef);
    void setDiffRefCoef(Cor* diff_ref_coef);
    void setSpecRefCoef(Cor* spec_ref_coef);
    void setShineCoef(float shine_coef);
    void setTriangulos(vector<Triangulo*>* triangulos);
    vector<Triangulo*>& getTriangulos() const {return *triangulos;};
    Cor* getAmbRefCoef();
    Cor* getDiffRefCoef();
    Cor* getSpecRefCoef();
    float getShineCoef();
    Ponto* Centro();
    void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao, bool CPP=false);
    void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP);
    void AplicaTransformacaoNosVetores(Matriz* matrizDeTransformacao, bool CPP);    
    void RotacionaVetores(float x, float y, float z);    
    void FazTransformadaDeViewPort(SistemaGrafico* sg);
    void SalvaNoStream(ostream &output);
    static ObjetoTriangularizado* LeDoStream(istream &input, int versao);

  private:
    Cor* amb_ref_coef;
    Cor* diff_ref_coef;
    Cor* spec_ref_coef;
    float shine_coef;
    vector<Triangulo*>* triangulos;

};

//---------------------------------------------------------------------------
#endif
