//---------------------------------------------------------------------------

#ifndef PontoH
#define PontoH

#include "ObjetoGrafico.h"

class SistemaGrafico;
//---------------------------------------------------------------------------
class Ponto : public ObjetoGrafico{

  public:
    Ponto(string nome, float _x, float _y, float _z, float _w = 1.0);
    Ponto(const Ponto& outro);
    Ponto();
    float GetX(){ return x;}
    float GetY(){ return y;}
    float GetZ(){ return z;}
    float GetW(){ return w;}
    void SetX(float valor);
    void SetY(float valor);
    void SetZ(float valor);
    void SetW(float valor);
    float GetXWindow(){ return xWin;}
    float GetYWindow(){ return yWin;}
    float GetZWindow(){ return zWin;}
    float GetWWindow(){ return xWin;}
    void SetXWindow(float valor);
    void SetYWindow(float valor);
    void SetZWindow(float valor);
    void SetWWindow(float valor);
    int GetXViewPort(){ return xViewPort;}
    int GetYViewPort(){return yViewPort;}
    void FazTransformadaDeViewPort(SistemaGrafico* sg); // Usado pelo ray tracing, atualiza X e Y da Window com o valores do Viewport

    bool GetPontoLuz();
    void SetPontoLuz(bool _ponto);

    Ponto* Centro();
    virtual void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao,bool CPP=false);
    virtual void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP);
    virtual void SalvaNoStream(ostream &o);
    static Ponto* LeDoStream(istream &i, int versao);

  private:
    float x, y, z, w;
    float xWin, yWin, wWin, zWin;

    // Usado pelo Ray-Tracing, chamar FazTransformadaDeViewPort para atualizar valores
    int xViewPort, yViewPort;
    float pontoLuz;
};
#endif
