//---------------------------------------------------------------------------
#pragma hdrstop
#include <Math.h>

#include "PontoSimples.h"
#include "Ponto.h"
//---------------------------------------------------------------------------
PontoSimples::PontoSimples()
{
  x=0.0;
  y=0.0;
  z=0.0;
  normalizado = false;
}
//---------------------------------------------------------------------------
PontoSimples::PontoSimples(const Ponto& p, bool window)
{
  if(window){
    x = p.GetXWindow();
    y = p.GetYWindow();
    z = p.GetZWindow();
  } else {
    x = p.GetX();
    y = p.GetY();
    z = p.GetZ();
  }

  normalizado = false;
}
//---------------------------------------------------------------------------
PontoSimples::PontoSimples(float _x, float _y, float _z)
{
  x=_x;
  y=_y;
  z=_z;
  normalizado = false;  
}
//---------------------------------------------------------------------------
float PontoSimples::Distancia(PontoSimples& outro)
{
  return fabs(sqrt((outro.X() - x)*(outro.X() - x) + (outro.Y() - y)*(outro.Y() - y) + (outro.Z() - z)*(outro.Z() - z))); 
}
//---------------------------------------------------------------------------
PontoSimples PontoSimples::operator-(PontoSimples& outro)
{
  return PontoSimples(x - outro.X(), y - outro.Y(), z - outro.Z());
}
//---------------------------------------------------------------------------
PontoSimples PontoSimples::operator+(PontoSimples& outro)
{
  return PontoSimples(x + outro.X(), y + outro.Y(), z + outro.Z());
}
//---------------------------------------------------------------------------
PontoSimples PontoSimples::operator*(float c)
{
  return PontoSimples(x*c, y*c, z*c);
}
//---------------------------------------------------------------------------
float PontoSimples::Normal()
{
  if(!normalizado) {
    try{
      normal = sqrt(x*x + y*y + z*z);
      normalizado = true;
    }catch(...){
      float x = normal;
    }
  }
  return normal;
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
