//---------------------------------------------------------------------------
#pragma hdrstop

#include "Reta.h"
#include "Ponto.h"
//---------------------------------------------------------------------------
Reta::Reta(string nome, Ponto* _p1, Ponto* _p2)
 : ObjetoGrafico(nome)
{
  p1 = _p1;
  p2 = _p2;
}
//---------------------------------------------------------------------------
Reta::Reta(string nome)
 : ObjetoGrafico(nome)
{
}
//---------------------------------------------------------------------------
Reta::~Reta()
{
  delete p1;
  delete p2;
}
//---------------------------------------------------------------------------
Ponto& Reta::GetP1()
{
  return *p1;
}
//---------------------------------------------------------------------------
Ponto& Reta::GetP2()
{
  return *p2;
}
//---------------------------------------------------------------------------
void Reta::SetP1(Ponto* _p1)
{
  p1 = _p1;
}
//---------------------------------------------------------------------------
void Reta::SetP2(Ponto* _p2)
{
  p2 = _p2;
}
//---------------------------------------------------------------------------
Ponto* Reta::Centro()
{
  return new Ponto("Centro",(p1->GetX() + p2->GetX())/2,(p1->GetY() + p2->GetY())/2, (p1->GetZ() + p2->GetZ())/2);
}
//---------------------------------------------------------------------------
void Reta::AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao,bool CPP)
{
    Ponto* centro = NULL;
    if (!CPP)
      centro = Centro();
    Matriz* matriz = CriarMatrizTransformacoes(translacao,escalonamento,rotacao,centro);
    AplicaTransformacaoNoPonto(p1, matriz,CPP);
    AplicaTransformacaoNoPonto(p2, matriz,CPP);
    delete matriz;
    delete centro;
}
//---------------------------------------------------------------------------

void Reta::AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP)
{
  AplicaTransformacaoNoPonto(p1, matrizDeTransformacao,CPP);
  AplicaTransformacaoNoPonto(p2, matrizDeTransformacao,CPP);
}
//---------------------------------------------------------------------------
void Reta::SalvaNoStream(ostream &output)
{
  ObjetoGrafico::SalvaNoStream(output);
  p1->SalvaNoStream(output);
  p2->SalvaNoStream(output);
}
//---------------------------------------------------------------------------
Reta* Reta::LeDoStream(istream &input, int versao)
{
  string nome = ObjetoGrafico::LeNomeDoStream(input);
  Ponto* p1 = Ponto::LeDoStream(input, versao);
  Ponto* p2 = Ponto::LeDoStream(input, versao);
  return new Reta(nome,p1,p2);
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
