#ifndef SuperficiesH
#define SuperficiesH

#include <vector>
#include "Curva.h"
#include "ObjetoGrafico.h"

class Matriz;
class Ponto;

#define VetorPontos vector<Ponto*>
#define MatrizPontos vector<VetorPontos>

//---------------------------------------------------------------------------
class Superficie : public ObjetoGrafico{

  public:

    Superficie(string nome, MatrizPontos* _matrizPontos,tipoCurva _tipo);
    ~Superficie();
    Ponto* Centro();
    virtual void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao, bool CPP=false);
    virtual void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP);
    Ponto* GeraPonto(float s, float t);
    void SalvaNoStream(ostream &output);
    static Superficie* LeDoStream(istream &input,int versao);
    vector<Matriz*>* GetMatrizMGMT(Eixo eixo);

  private:
    vector<Matriz*>* GeraMatrizMGMT(Eixo eixo);
    MatrizPontos* matrizPontos;
    unsigned int xDim, yDim;
    tipoCurva tipo;
    vector<Matriz*>* matrizMGMTX, *matrizMGMTY, *matrizMGMTZ;
    void ApagaMatrizes();
};

//---------------------------------------------------------------------------
#endif
