//---------------------------------------------------------------------------

#ifndef TrianguloH
#define TrianguloH

#include <string.h>
#include "Wireframe.h"

class SistemaGrafico;
class ObjetoTriangularizado;
class PontoSimples;

//---------------------------------------------------------------------------
class Triangulo : public WireFrame
{
  public:
    Triangulo(string nome, Ponto* p1, Ponto* p2, Ponto* p3,Ponto* vetor);
    Ponto* PontoComMaiorY() const;
    Ponto* PontoComMenorY() const;
    Ponto* PontoComYIntermediario() const;
    Ponto* GetP1();
    Ponto* GetP2();
    Ponto* GetP3();
    Ponto* GetVetor();
    PontoSimples* GetVetorSimples() { return vetorSimples;}
    ObjetoTriangularizado* GetPai() { return pai;}
    void SetPai(ObjetoTriangularizado* _pai) { pai = _pai;}
    void FazTransformadaDeViewPort(SistemaGrafico* sg);
    void AplicaTransformacaoNoVetor(Matriz* matrizDeTransformacao, bool CPP);
    void SalvaNoStream(ostream &output);
    static Triangulo* LeDoStream(istream &input,int versao);

  private:
    Ponto* vetor;
    PontoSimples* vetorSimples;
    ObjetoTriangularizado* pai;
};

//---------------------------------------------------------------------------
#endif
 