#include <vcl.h>
#pragma hdrstop

#include "UGer.h"
#include "UInsObj.h"
#include "UTrans.h"
#include "USisGrafico.h"
#include "About.h"
#include "Ponto.h"
#include "Reta.h"
#include "WireFrame.h"
#include "Curva.h"
#include "Window.h"
#include "PontoDeLuz.h"
#include "ObjetoTriangularizado.h"
#include "Triangulo.h"
#include <vector.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGerente *Gerente;
//---------------------------------------------------------------------------
__fastcall TGerente::TGerente(TComponent* Owner)
        : TForm(Owner)
{
  sg = new SistemaGrafico(Viewport->Canvas);
  ColorDialog->Color = TColor(0x00FFFFFF);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::InsereObjetoClick(TObject *Sender)
{
  Incluir1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::ZoomInClick(TObject *Sender)
{
  sg->ZoomIn(atoi(PassoEB->Text.c_str()));
}
//---------------------------------------------------------------------------
void __fastcall TGerente::RightClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),DIREITA);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::LeftClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),ESQUERDA);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::UpClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),CIMA);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::DownClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),BAIXO);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::ZoomOutClick(TObject *Sender)
{
  sg->ZoomOut(atoi(PassoEB->Text.c_str()));
}
//---------------------------------------------------------------------------
void __fastcall TGerente::PassoEBExit(TObject *Sender)
{
  DecimalSeparator = '.';
  try{
    PassoEB->Text.ToDouble();
  }catch(EConvertError& e){
    MessageBox(Handle,"Digite apenas valores reais - Ex: 150.25","ATENO",MB_OK);
    PassoEB->Text = "0";
    ActiveControl = PassoEB;
    return;
  }

  if(atoi(PassoEB->Text.c_str()) <0 || atoi(PassoEB->Text.c_str()) > 30){
    MessageBox(NULL,"O passo deve estar entre 1% e 30%","ATENO", MB_OK);
    PassoEB->Text = "10";
  }
}
//---------------------------------------------------------------------------
// Executado quando o viewport precisa ser repintado (depois que uma
// janela que estava em cima do viewport  retirada por exemplo
void __fastcall TGerente::ViewportPaint(TObject *Sender)
{
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------
void __fastcall TGerente::AplicTrans2DClick(TObject *Sender)
{
    if (!Transformacao)
      Transformacao = new TTransformacao(this);
    Transformacao->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TGerente::PopupMenu1Popup(TObject *Sender)
{
    if (Itens->ItemIndex == -1){
        PopupMenu1->Items->Items[0]->Enabled = false;
        PopupMenu1->Items->Items[1]->Enabled = false;
        PopupMenu1->Items->Items[2]->Enabled = false;
    } else {
        PopupMenu1->Items->Items[0]->Enabled = true;
        PopupMenu1->Items->Items[1]->Enabled = true;
        PopupMenu1->Items->Items[2]->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TGerente::RotacionaEsquerdaClick(TObject *Sender)
{
   if (ComboBoxEixo->ItemIndex == 0)
   {
     sg->RotacionaWindowEixoX(-15.0);
   } else if (ComboBoxEixo->ItemIndex == 1)
   {
     sg->RotacionaWindowEixoY(-15.0);
   } else
     sg->RotacionaWindowEixoZ(-15.0);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::RotacionaDireitaClick(TObject *Sender)
{
   if (ComboBoxEixo->ItemIndex == 0)
   {
     sg->RotacionaWindowEixoX(15.0);
   } else if (ComboBoxEixo->ItemIndex == 1)
   {
     sg->RotacionaWindowEixoY(15.0);
   } else
     sg->RotacionaWindowEixoZ(15.0);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::AtivaClippingClick(TObject *Sender)
{
  sg->Clipping(AtivaClipping->Checked);
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------
void __fastcall TGerente::EsqClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),ESQUERDA);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::BaixoClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),BAIXO);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::DirClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),DIREITA);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::CimaClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),CIMA);
}
//---------------------------------------------------------------------------


void __fastcall TGerente::FrenteClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),FRENTE);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::TrazClick(TObject *Sender)
{
  sg->Mover(atoi(PassoEB->Text.c_str()),TRAZ);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Sair1Click(TObject *Sender)
{
  exit(EXIT_SUCCESS);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Inserir1Click(TObject *Sender)
{
  Incluir1Click(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TGerente::Sobre1Click(TObject *Sender)
{
  if (!AboutBox)
    AboutBox = new TAboutBox(this);
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Abrir1Click(TObject *Sender)
{
  if(AbrirArquivo->Execute()==ID_OK) {
    Novo1Click(Sender);
    sg->AbreDoArquivo(AbrirArquivo->FileName.c_str());
    arquivoAtual = AbrirArquivo->FileName.c_str();
    AtualizaListBox();
  }
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Salvar1Click(TObject *Sender)
{
  if(SalvarArquivo->Execute()==ID_OK) {
    sg->SalvaNoArquivo(SalvarArquivo->FileName.c_str());
    arquivoAtual = SalvarArquivo->FileName.c_str();
  }
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Adiciona1Click(TObject *Sender)
{
  if(AbrirArquivo->Execute()==ID_OK) {
    sg->AbreDoArquivo(AbrirArquivo->FileName.c_str());
    AtualizaListBox();
  }
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Novo1Click(TObject *Sender)
{
  delete sg;
  sg = new SistemaGrafico(Viewport->Canvas);
  arquivoAtual.clear();
  Gerente->Itens->Items->Clear();
  RadioButton1->Checked = true;
  sg->setProjecaoParalela(true);
  AtivaClipping->Checked = false;
  if (!IncluirObjeto)
    IncluirObjeto = new TIncluirObjeto(this);
  IncluirObjeto->SetSistemaGrafico(sg);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Apaga1Click(TObject *Sender)
{
  sg->Remove(Gerente->Itens->ItemIndex);
  Gerente->Itens->Items->Delete(Gerente->Itens->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::Salvar2Click(TObject *Sender)
{
  if(arquivoAtual.empty())
    Salvar1Click(Sender);
  else
    sg->SalvaNoArquivo(arquivoAtual.c_str());
}
//---------------------------------------------------------------------------
void TGerente::AtualizaListBox()
{
  Gerente->Itens->Items->Clear();
  vector<ObjetoGrafico*> lista = sg->GetListaObjetos();
  for(unsigned int i=0;i<lista.size();i++) {
    ObjetoGrafico* atual = lista[i];
    AnsiString s;
    Ponto* ponto = dynamic_cast<Ponto*> (atual);
    if (ponto)
      s = "Ponto: ";
    Reta* reta = dynamic_cast<Reta*> (atual);
    if (reta)
      s = "Reta: ";
    WireFrame* wireframe = dynamic_cast<WireFrame*>(atual);
    if(wireframe)
      s = "WireFrame: ";
    Curva* curva = dynamic_cast<Curva*>(atual);
    if (curva)
      s = "Curva: ";
    Gerente->Itens->AddItem(s+AnsiString(atual->getNome().c_str()), NULL);
  }
}
//---------------------------------------------------------------------------
void __fastcall TGerente::Incluir1Click(TObject *Sender)
{
  if (!IncluirObjeto)
    IncluirObjeto = new TIncluirObjeto(this);
  IncluirObjeto->SetSistemaGrafico(sg);
  IncluirObjeto->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::RadioButton1Click(TObject *Sender)
{
  sg->setProjecaoParalela(true);
}
//---------------------------------------------------------------------------

void __fastcall TGerente::RadioButton2Click(TObject *Sender)
{
  sg->setProjecaoParalela(false);
}
//---------------------------------------------------------------------------
void __fastcall TGerente::ViewportMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  float fator = (atof(PassoEB->Text.c_str())/100)*6;

  if (Shift.Contains(ssRight)){
    if (valorY!=0)
      sg->Mover(fator*(Y - valorY),TRAZ);
  }
  if(Shift.Contains(ssLeft)){
    if (valorX!=0)
      sg->Mover(fator*(X - valorX),DIREITA);
    if (valorY!=0)
      sg->Mover(fator*(Y - valorY),BAIXO);
  }

  valorX = X;
  valorY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TGerente::ViewportMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  valorX = X;
  valorY = Y;
}
//---------------------------------------------------------------------------
void TGerente::AbrirXML(string documento)
{
  try {
    XMLDocument1->FileName = WideString(documento.c_str());
    XMLDocument1->Active = true;
    SistemaGrafico* sistema = new SistemaGrafico(Viewport->Canvas);
    _di_IXMLNode scenario = XMLDocument1->DocumentElement;
    _di_IXMLNodeList filhosScenario = scenario->ChildNodes;
    int nrAmbientLight = 0;
    int window = 0;
    for (int k = 0; k < filhosScenario->Count; k++)
    {
      WideString nomeDoNodoFilhosScenario = (*filhosScenario)[k]->GetNodeName();
      if( nomeDoNodoFilhosScenario == WideString("window"))
      {
        window++;
        // Valores da Window
        _di_IXMLNode window = (*filhosScenario)[k];
        _di_IXMLNodeList filhosWindow = window->ChildNodes;
        Ponto* p1 = NULL;
        Ponto* p2 = NULL;
        Ponto* ponto = NULL;
        int nrPointx = 0;
        int nrVector = 0;
        for(int i=0;i<filhosWindow->Count;i++)
        {
          WideString nomeDoNodoFilhosWindow = (*filhosWindow)[i]->GetNodeName();
          if( nomeDoNodoFilhosWindow == WideString("point"))
          {
            nrPointx++;
            AnsiString x = (*filhosWindow)[i]->GetAttribute(WideString("x"));
            AnsiString y = (*filhosWindow)[i]->GetAttribute(WideString("y"));
            AnsiString z = (*filhosWindow)[i]->GetAttribute(WideString("z"));
            ponto = new Ponto("p1 window", atof(x.c_str()), atof(y.c_str()), atof(z.c_str()));
            if(!p1)
              p1 = ponto;
            else
              p2 = ponto;
/*
            if(p1 && p2)
              sistema->setPontosWindow(p1, new Ponto("p2", p1->GetX(), p2->GetY(), p1->GetZ()),
                                       p2, new Ponto("p4", p2->GetX(), p1->GetY(), p2->GetZ()));
*/
          } else if (nomeDoNodoFilhosWindow == WideString("vector"))
          {
            nrVector++;
            AnsiString a = (*filhosWindow)[i]->GetAttribute(WideString("a"));
            AnsiString b = (*filhosWindow)[i]->GetAttribute(WideString("b"));
            AnsiString c = (*filhosWindow)[i]->GetAttribute(WideString("c"));
//            sistema->setVPNWindow(new Ponto("VPN", atof(a.c_str()), atof(b.c_str()), atof(c.c_str())));
          }
        }
        if (nrPointx != 2){
          MessageBox(Handle, "Window precisa de dois pontos", "ERRO AO LER O ARQUIVO", MB_OK);
          return;
        }
        if (nrVector != 1){
          MessageBox(Handle, "Window precisa de um vetor", "ERRO AO LER O ARQUIVO", MB_OK);
          return;
        }
      }
      else if(nomeDoNodoFilhosScenario == WideString("light_spot"))
      {
        _di_IXMLNode lightSpot = (*filhosScenario)[k];
        AnsiString lightSpotR = lightSpot->GetAttribute(WideString("r"));
        AnsiString lightSpotG = lightSpot->GetAttribute(WideString("g"));
        AnsiString lightSpotB = lightSpot->GetAttribute(WideString("b"));
        if(lightSpot->ChildNodes->GetCount() != 1){
          MessageBox(Handle, "Light Spot precisa em 1 ponto", "ERRO AO LER O ARQUIVO", MB_OK);
          return;
        }
        _di_IXMLNode filhoLightSpot = (*lightSpot->ChildNodes)[0];
        AnsiString lightSpotPointX = filhoLightSpot->GetAttribute(WideString("x"));
        AnsiString lightSpotPointY = filhoLightSpot->GetAttribute(WideString("y"));
        AnsiString lightSpotPointZ = filhoLightSpot->GetAttribute(WideString("z"));
        Ponto* pontoDeLuz = new Ponto("Light Spot",
                                              atof(lightSpotPointX.c_str()),
                                              atof(lightSpotPointY.c_str()),
                                              atof(lightSpotPointZ.c_str()));
        pontoDeLuz->SetCor(Cor(atof(lightSpotR.c_str()),
                               atof(lightSpotG.c_str()),
                               atof(lightSpotB.c_str())));
        sistema->AdicionaPontoDeLuz(pontoDeLuz);
        Itens->AddItem("Ponto Luz:", NULL);

      }
      else if(nomeDoNodoFilhosScenario == WideString("ambient_light"))
      {
        nrAmbientLight++;
        _di_IXMLNode ambientLight = (*filhosScenario)[k];
        AnsiString ambientLightR = ambientLight->GetAttribute(WideString("r"));
        AnsiString ambientLightG = ambientLight->GetAttribute(WideString("g"));
        AnsiString ambientLightB = ambientLight->GetAttribute(WideString("b"));
        sistema->SetCorLuzAmbiente(Cor(
                                          atof(ambientLightR.c_str()),
                                          atof(ambientLightG.c_str()),
                                          atof(ambientLightB.c_str())));
      }
      else if(nomeDoNodoFilhosScenario == WideString("object"))
      {
        _di_IXMLNode object = (*filhosScenario)[k];
        _di_IXMLNodeList filhosObject = object->ChildNodes;
        ObjetoTriangularizado* objeto = new ObjetoTriangularizado("objeto", NULL, NULL, NULL, 0.0, NULL);
        vector<Triangulo*>* triangulos = new vector<Triangulo*>;

        for(int i=0;i<filhosObject->Count;i++)
        {
          WideString nomeDoNodoFilhosObjeto = (*filhosObject)[i]->GetNodeName();
          if(nomeDoNodoFilhosObjeto == WideString("triangle"))
          {
            _di_IXMLNodeList filhosTriangulo = (*filhosObject)[i]->ChildNodes;
            Ponto* p1 = NULL;
            Ponto* p2 = NULL;
            Ponto* p3 = NULL;
            Ponto* ponto = NULL;
            Ponto* vetor = NULL;

            for(int j=0;j<filhosTriangulo->Count;j++)
            {
              if((*filhosTriangulo)[j]->GetNodeName() == WideString("point"))
              {
                AnsiString x = (*filhosTriangulo)[j]->GetAttribute(WideString("x"));
                AnsiString y = (*filhosTriangulo)[j]->GetAttribute(WideString("y"));
                AnsiString z = (*filhosTriangulo)[j]->GetAttribute(WideString("z"));
                ponto = new Ponto("ponto triangulo", atof(x.c_str()), atof(y.c_str()), atof(z.c_str()));
                if (!p1)
                  p1 = ponto;
                else if (!p2)
                  p2 = ponto;
                else
                  p3 = ponto;
              }
              else if ((*filhosTriangulo)[j]->GetNodeName() == WideString("vector"))
              {
                AnsiString a = (*filhosTriangulo)[j]->GetAttribute(WideString("a"));
                AnsiString b = (*filhosTriangulo)[j]->GetAttribute(WideString("b"));
                AnsiString c = (*filhosTriangulo)[j]->GetAttribute(WideString("c"));
                vetor = new Ponto("normal",atof(a.c_str()),atof(b.c_str()),atof(c.c_str()));
              }
            }
            Triangulo* triangulo = new Triangulo("Triangulo",p1, p2,p3, vetor);
            triangulos->push_back(triangulo);
          }
          else if(nomeDoNodoFilhosObjeto == WideString("diff_ref_coef"))
          {
            AnsiString diffRefCoefR = (*filhosObject)[i]->GetAttribute(WideString("r"));
            AnsiString diffRefCoefG = (*filhosObject)[i]->GetAttribute(WideString("g"));
            AnsiString diffRefCoefB = (*filhosObject)[i]->GetAttribute(WideString("b"));
            objeto->setDiffRefCoef(new Cor(
                                          atof(diffRefCoefR.c_str()),
                                          atof(diffRefCoefG.c_str()),
                                          atof(diffRefCoefB.c_str())));
          }
          else if(nomeDoNodoFilhosObjeto == WideString("amb_ref_coef"))
          {
            AnsiString ambRefCoefR = (*filhosObject)[i]->GetAttribute(WideString("r"));
            AnsiString ambRefCoefG = (*filhosObject)[i]->GetAttribute(WideString("g"));
            AnsiString ambRefCoefB = (*filhosObject)[i]->GetAttribute(WideString("b"));
            objeto->setAmbRefCoef(new Cor(
                                          atof(ambRefCoefR.c_str()),
                                          atof(ambRefCoefG.c_str()),
                                          atof(ambRefCoefB.c_str())));
          }
          else if(nomeDoNodoFilhosObjeto == WideString("spec_ref_coef"))
          {
            AnsiString specRefCoefR = (*filhosObject)[i]->GetAttribute(WideString("r"));
            AnsiString specRefCoefG = (*filhosObject)[i]->GetAttribute(WideString("g"));
            AnsiString specRefCoefB = (*filhosObject)[i]->GetAttribute(WideString("b"));
            objeto->setSpecRefCoef(new Cor(
                                          atof(specRefCoefR.c_str()),
                                          atof(specRefCoefG.c_str()),
                                          atof(specRefCoefB.c_str())));
          }
          else if(nomeDoNodoFilhosObjeto == WideString("shine_coef"))
          {
            AnsiString shineCoef = (*filhosObject)[i]->GetAttribute(WideString("value"));
            objeto->setShineCoef(atof(shineCoef.c_str()));
          }
        }
        objeto->setTriangulos(triangulos);
        sistema->AdicionaObjetoTriangularizado(objeto);
        Itens->AddItem("Objeto Triangularizado:", NULL);
      }
    }

    if(sg)
      delete sg;
    sg = sistema;

  } catch (EDOMParseError& excessao){
    AnsiString texto = AnsiString("Erro no arquivo XML, linha ") + excessao.Line + AnsiString(", ")
      + AnsiString("posicao ") + excessao.LinePos + AnsiString("\nMotivo: ") + excessao.Reason;

    MessageBox(Handle, texto.c_str(), "ERRO AO LER O ARQUIVO", MB_OK);
  } catch (...) {
    MessageBox(Handle, "Erro no XML", "ERRO AO LER O ARQUIVO", MB_OK);
  }
  AtualizaListBox();
  ColorDialog->Color = (TColor)sg->GetCorLuzAmbiente().RBGParaNumero();
  PaintBoxCor->Refresh();
  RayTracing->Checked = false;
  RadioButton1->Checked = true;
  AtivaClipping->Checked = false;  
  sg->setProjecaoParalela(true);

}
//---------------------------------------------------------------------------
void __fastcall TGerente::A1Click(TObject *Sender)
{
  if(AbrirArquivoXML->Execute() == ID_OK)
    AbrirXML(AbrirArquivoXML->FileName.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TGerente::RayTracingClick(TObject *Sender)
{
  sg->RayTracing(RayTracing->Checked);
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::CorLuzAmbienteClick(TObject *Sender)
{
  if (ColorDialog->Execute() == ID_OK) {
    PaintBoxCor->Refresh();
    sg->SetCorLuzAmbiente(Cor(ColorDialog->Color));
    sg->DesenhaTudo();
  }
}
//---------------------------------------------------------------------------

void __fastcall TGerente::PaintBoxCorPaint(TObject *Sender)
{
  PaintBoxCor->Canvas->Brush->Color = ColorDialog->Color;
  PaintBoxCor->Canvas->FillRect(TRect(0,0,PaintBoxCor->Width,PaintBoxCor->Height));
}
//---------------------------------------------------------------------------

void __fastcall TGerente::ValorKExit(TObject *Sender)
{
  sg->SetFatorK(atof(ValorK->Text.c_str()));
}
//---------------------------------------------------------------------------

void __fastcall TGerente::CBAmbienteClick(TObject *Sender)
{
  sg->SetComponenteAmbiente(CBAmbiente->Checked);
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::CBDifusaClick(TObject *Sender)
{
  sg->SetComponenteDifuso(CBDifusa->Checked);
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::CBEspecularClick(TObject *Sender)
{
  sg->SetComponenteEspecular(CBEspecular->Checked);
  sg->DesenhaTudo();
}
//---------------------------------------------------------------------------
void __fastcall TGerente::AnimarClick(TObject *Sender)
{
  sg->AtivaAnimacao(Gerente->Itens->ItemIndex);          
}
//---------------------------------------------------------------------------

void __fastcall TGerente::TimerTimer(TObject *Sender)
{
  sg->Animacao();
}
//---------------------------------------------------------------------------

void __fastcall TGerente::CBSombraClick(TObject *Sender)
{
  sg->SetSombra(CBSombra->Checked);
  sg->DesenhaTudo();

}
//---------------------------------------------------------------------------

