//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UInsObj.h"
#include "UGer.h"
#include "USisGrafico.h"
#include "Ponto.h"
#include "Cor.h"
#include "WireFrame.h"
#include "Reta.h"
#include "Curva.h"
#include "Matriz.h"
#include "Triangulo.h"
#include "ObjetoTriangularizado.h"
#include "Superficies.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TIncluirObjeto *IncluirObjeto;
//---------------------------------------------------------------------------
__fastcall TIncluirObjeto::TIncluirObjeto(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TIncluirObjeto::SetSistemaGrafico(SistemaGrafico* s)
{
  sistemaGrafico = s;
  contador =0;
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::OKClick(TObject *Sender)
{
  AnsiString s;
  bool OK = true;
  switch(PageControl1->TabIndex){
    Ponto* p;
    Ponto* p1;
    Ponto* p2;
    Reta* reta;
    WireFrame* wireframe;
    case 0: // Ponto
      p = new Ponto(NomeObjeto->Text.c_str(),atof(XPonto->Text.c_str()),atof(YPonto->Text.c_str()),atof(ZPonto->Text.c_str()));
      p->SetCor(ColorDialog->Color);
      if (CBPontoDeLuz->Checked){
        p->SetPontoLuz(true);
        sistemaGrafico->AdicionaPontoDeLuz(p);
      }
      else
        sistemaGrafico->InserePonto(p);
      s = s +  (CBPontoDeLuz->Checked ? AnsiString("Ponto de Luz: ") : AnsiString("Ponto: "));
      s = s + NomeObjeto->Text.c_str();
      Gerente->Itens->AddItem(s, NULL);
      break;
    case 1: // Reta
      p1 = new Ponto("",atof(X1Reta->Text.c_str()),
        atof(Y1Reta->Text.c_str()),
        atof(Z1Reta->Text.c_str()));
      p2 = new Ponto("",atof(X2Reta->Text.c_str()),
        atof(Y2Reta->Text.c_str()),
        atof(Z2Reta->Text.c_str()));
      reta = new Reta(NomeObjeto->Text.c_str(),p1,p2);
      reta->SetCor(ColorDialog->Color);
      sistemaGrafico->InsereReta(reta);
      s = AnsiString("Reta: ") + NomeObjeto->Text.c_str();;
      Gerente->Itens->AddItem(s, NULL);
      break;
    case 2: // Wire Frame
        wireframe = new WireFrame(NomeObjeto->Text.c_str());
        if (!(pontosWF && vetorArestas)){
          OK=false;
          MessageBox(Handle,"Adicione os pontos e as arestas antes","ATENO",MB_OK);
        }else if (pontosWF->size()>2 && vetorArestas->size()>1){
          wireframe->SetPontos(pontosWF);
          wireframe->SetArestas(vetorArestas);
          sistemaGrafico->InsereWireFrame(wireframe);
          wireframe->SetCor(ColorDialog->Color);
          s = AnsiString("Wireframe") + NomeObjeto->Text.c_str();
          Gerente->Itens->AddItem(s, NULL);
        } else {
          MessageBox(Handle,"O wire frame precisa ter no mnimo trs pontos e duas arestas","ATENO",MB_OK);
          OK=false;
        }
      break;
    case 3:  //Curva
      CriaNovaCurva(OK);
      break;
    case 4: // Superfcie
      CriaNovaSuperficie(OK);
      break;
    case 5: // Objeto Triangularizado
      CriaNovoObjetoTriangularizado(OK);
      break;

  }
  if (OK)
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::CancelarClick(TObject *Sender)
{
   if (pontosWF){
     for (unsigned int i=0; i<pontosWF->size();i++){
       delete (*pontosWF)[i];
     }
     delete pontosWF;
   }

   if (pontosCurva){
     for (unsigned int i=0; i<pontosCurva->size();i++){
       delete (*pontosCurva)[i];
     }
     delete pontosCurva;
   }
   if (vetorArestas){
     for (unsigned int i=0; i<vetorArestas->size();i++){
       delete (*vetorArestas)[i];
     }
     delete vetorArestas;
   }
   if (vetorTriangulos){
     for (unsigned int i=0; i<vetorTriangulos->size();i++){
       delete (*vetorTriangulos)[i];
     }
     delete vetorTriangulos;
   }

  Close();
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::AdicionaPontoWFClick(TObject *Sender)
{
  if (!pontosWF)
    pontosWF = new vector<Ponto*>;
  char temp[256];
  itoa(contador, temp, 10);
  contador++;
  Ponto* p = new Ponto("P"+string(temp),atof(XWF->Text.c_str()),atof(YWF->Text.c_str()),atof(ZWF->Text.c_str()));
  pontosWF->push_back(p);

  AnsiString str = AnsiString(p->getNome().c_str()) + "- ("+ XWF->Text + "," + YWF->Text + "," + ZWF->Text + ")";
  ListaPontosWF->Items->Add(str);

  Ponto1->Items->Add(AnsiString(p->getNome().c_str()));
  Ponto2->Items->Add(AnsiString(p->getNome().c_str()));
  Ponto1->Enabled=true;
  Ponto2->Enabled=true;
  Ponto1->ItemIndex = Ponto1->Items->Count-1;
  Ponto2->ItemIndex = Ponto2->Items->Count-1;

  XWF->Text = "0";
  YWF->Text = "0";
  ZWF->Text = "0";

  if(ListaPontosWF->Count >0)
    AdicionaAresta->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::AdicionaPontoCurvaClick(TObject *Sender)
{
  if (!pontosCurva)
    pontosCurva = new vector<Ponto*>;
  char temp[256];
  itoa(pontosCurva->size(), temp, 10);
  Ponto* p = new Ponto("P"+string(temp),atof(XCurva->Text.c_str()),atof(YCurva->Text.c_str()),atof(ZCurva->Text.c_str()));
  pontosCurva->push_back(p);

  AnsiString str = AnsiString(p->getNome().c_str()) + "- ("+ XCurva->Text + "," + YCurva->Text + "," + ZCurva->Text + ")";
  ListaPontosCurva->Items->Add(str);

  XCurva->Text = "0";
  YCurva->Text = "0";
  ZCurva->Text = "0";
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::FormShow(TObject *Sender)
{
  pontosWF = NULL;
  pontosCurva = NULL;
  vetorArestas = NULL;
  vetorTriangulos = NULL;
  NomeObjeto->Text = "";
  XPonto->Text = "0";
  YPonto->Text = "0";
  ZPonto->Text = "0";
  X1Reta->Text = "0";
  Y1Reta->Text = "0";
  Z1Reta->Text = "0";
  X2Reta->Text = "0";
  Y2Reta->Text = "0";
  Z2Reta->Text = "0";
  XWF->Text = "0";
  YWF->Text = "0";
  ZWF->Text = "0";
  XCurva->Text = "0";
  YCurva->Text = "0";
  ZCurva->Text = "0";
  X1Triangulo->Text = "0";
  X2Triangulo->Text = "0";
  X3Triangulo->Text = "0";
  VetorXTriangulo->Text = "0";
  Y1Triangulo->Text = "0";
  Y2Triangulo->Text = "0";
  Y3Triangulo->Text = "0";
  VetorYTriangulo->Text = "0";
  Z1Triangulo->Text = "0";
  Z2Triangulo->Text = "0";
  Z3Triangulo->Text = "0";
  VetorZTriangulo->Text = "0";
  Polimento->Text = "0";

  CBPontoDeLuz->Checked = false;

  ColorDialog->Color=clBlack;
  ColorDialogDifusa->Color=clBlack;
  ColorDialogAmbiente->Color=clBlack;
  ColorDialogEspecular->Color=clBlack;
  ListaPontosWF->Items->Clear();
  ListaPontosCurva->Items->Clear();
  ListaArestas->Items->Clear();
  Ponto1->Clear();
  Ponto2->Clear();
  ListBoxTriangulos->Clear();

  const int XDIM = StringGrid->ColCount;
  const int YDIM = StringGrid->RowCount;

  for (int i=1;i<=XDIM;i++)
    for (int j=1;j<=YDIM;j++) {
      StringGrid->Objects[i][j]=NULL;
      StringGrid->Cells[i][j] = "";
    }

  StringGrid->ColCount = 5;
  StringGrid->RowCount = 5;

  RadioButtonBezier->Enabled = true;
  RadioButtonSpline->Enabled = true;

  Ponto1->Enabled = false;
  Ponto2->Enabled = false;
  contador =0;
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::CorClick(TObject *Sender)
{
  ColorDialog->Execute();
  PaintBoxCor->Canvas->Brush->Color = ColorDialog->Color;
  PaintBoxCor->Canvas->FillRect(TRect(0,0,PaintBoxCor->Width,PaintBoxCor->Height));
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::FormPaint(TObject *Sender)
{
  PaintBoxCor->Canvas->Brush->Color = ColorDialog->Color;
  PaintBoxCor->Canvas->FillRect(TRect(0,0,PaintBoxCor->Width,PaintBoxCor->Height));

  PaintBoxCorDifusa->Canvas->Brush->Color = ColorDialogDifusa->Color;
  PaintBoxCorDifusa->Canvas->FillRect(TRect(0,0,PaintBoxCorDifusa->Width,PaintBoxCorDifusa->Height));

  PaintBoxCorAmbiente->Canvas->Brush->Color = ColorDialogAmbiente->Color;
  PaintBoxCorAmbiente->Canvas->FillRect(TRect(0,0,PaintBoxCorAmbiente->Width,PaintBoxCorAmbiente->Height));

  PaintBoxCorEspecular->Canvas->Brush->Color = ColorDialogEspecular->Color;
  PaintBoxCorEspecular->Canvas->FillRect(TRect(0,0,PaintBoxCorEspecular->Width,PaintBoxCorEspecular->Height));
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::AdicionaArestaClick(TObject *Sender)
{
  if (!vetorArestas)
    vetorArestas = new vector<Reta*>;

  int pos1 = Ponto1->ItemIndex;
  int pos2 = Ponto2->ItemIndex;
  Ponto* p1 = (*pontosWF)[pos1];
  Ponto* p2 = (*pontosWF)[pos2];

  Reta* r = new Reta(
    (AnsiString(p1->getNome().c_str()) + "-" +
     AnsiString(p2->getNome().c_str())).c_str(),
     p1,p2);

  vetorArestas->push_back(r);

  ListaArestas->Items->Add(r->getNome().c_str());
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::Apagar1Click(TObject *Sender)
{
  int pos = ListaPontosWF->ItemIndex;
  vector<Ponto*>::iterator it = pontosWF->begin();
  Ponto* p = (*pontosWF)[pos];
  for(int i=0;i<pos;i++){it++;}
  Ponto1->Items->Delete(Ponto1->Items->IndexOf(p->getNome().c_str()));
  Ponto2->Items->Delete(Ponto2->Items->IndexOf(p->getNome().c_str()));
  if (vetorArestas) {
    for(unsigned int i=0;i<vetorArestas->size();i++){
      if(&(*vetorArestas)[i]->GetP1() == p || &(*vetorArestas)[i]->GetP2()==p ){
        ListaArestas->ItemIndex = i;
        MenuItem1Click(Sender);
      }
    }
  }

  delete (*pontosWF)[pos];
  pontosWF->erase(it);
  ListaPontosWF->Items->Delete(pos);
  Ponto1->ItemIndex=0;
  Ponto2->ItemIndex=0;

  if(ListaPontosWF->Count <=0){
    AdicionaAresta->Enabled = false;
    Ponto1->Enabled = false;
    Ponto2->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::MenuItem1Click(TObject *Sender)
{
  int pos = ListaArestas->ItemIndex;
  vector<Reta*>::iterator it = vetorArestas->begin();
  for(int i=0;i<pos;i++){it++;}
  vetorArestas->erase(it);
  ListaArestas->Items->Delete(pos);
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::PopupMenuPontosPopup(TObject *Sender)
{

    if (ListaPontosWF->ItemIndex == -1)
        PopupMenuPontos->Items->Items[0]->Enabled = false;
    else
        PopupMenuPontos->Items->Items[0]->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::PopupMenuArestasPopup(TObject *Sender)
{
    if (ListaArestas->ItemIndex == -1)
        PopupMenuArestas->Items->Items[0]->Enabled = false;
    else
        PopupMenuArestas->Items->Items[0]->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::PopupMenuCurvasPopup(TObject *Sender)
{
    if (ListaPontosCurva->ItemIndex == -1)
        PopupMenuCurvas->Items->Items[0]->Enabled = false;
    else
        PopupMenuCurvas->Items->Items[0]->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::ApagarPonto1Click(TObject *Sender)
{
  int pos = ListaPontosCurva->ItemIndex;
  vector<Ponto*>::iterator it = pontosCurva->begin();
  for(int i=0;i<pos;i++){it++;}
  delete (*pontosCurva)[pos];
  pontosCurva->erase(it);
  ListaPontosCurva->Items->Delete(pos);

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::AdicionarClick(TObject *Sender)
{
  if ((Ponto*)StringGrid->Objects[StringGrid->Col][StringGrid->Row])
    delete ((Ponto*)StringGrid->Objects[StringGrid->Col][StringGrid->Row]);
  StringGrid->Cells[StringGrid->Col][StringGrid->Row] = "(" + PontoSuperficieX->Text + "," + PontoSuperficieY->Text + "," + PontoSuperficieZ->Text +")";
  StringGrid->Objects[StringGrid->Col][StringGrid->Row] = (TObject*)new Ponto("Ponto",atoi(PontoSuperficieX->Text.c_str()), atoi(PontoSuperficieY->Text.c_str()), atoi(PontoSuperficieZ->Text.c_str()));
  if (StringGrid->Col == StringGrid->ColCount-1){
    if (StringGrid->Row != StringGrid->RowCount-1){
      StringGrid->Col = 1;
      StringGrid->Row++;
    }
  } else
    StringGrid->Col++;
  PontoSuperficieX->Text = "0";
  PontoSuperficieY->Text = "0";
  PontoSuperficieZ->Text = "0";
}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::AdicionarSuperficieClick(TObject *Sender)
{
  int incremento = RadioButtonBezier->Checked ? 3 : 1;
  if(ComboPosicao->ItemIndex == 0)
    StringGrid->RowCount += incremento;
  else
    StringGrid->ColCount += incremento;

  RadioButtonBezier->Enabled = false;
  RadioButtonSpline->Enabled = false;
}
//---------------------------------------------------------------------------
void TIncluirObjeto::CriaNovaSuperficie(bool &OK)
{
  const int XDIM = StringGrid->ColCount-1;
  const int YDIM = StringGrid->RowCount-1;

  for (int i=1;i<XDIM+1;i++)
    for (int j=1;j<YDIM+1;j++)
      if(!(Ponto*) StringGrid->Objects[i][j]) {
        MessageBox(Handle,"Adicione TODOS os pontos antes","ATENO",MB_OK);
        OK = false;
        return;
      }

  MatrizPontos* matrizPontos = new MatrizPontos;
  matrizPontos->resize(XDIM);
  for(int x = 0; x < XDIM; x++)
    (*matrizPontos)[x].resize(YDIM);

  for (int i=1;i<XDIM+1;i++)
    for (int j=1;j<YDIM+1;j++)
      (*matrizPontos)[i-1][j-1] = (Ponto*) StringGrid->Objects[i][j];

  AnsiString s("Superfcie: ");
  s += NomeObjeto->Text.c_str();
  tipoCurva tipo = BEZIER;
  if (RadioButtonSpline->Checked)
    tipo = SPLINE;

  Superficie* superficie = new Superficie(s.c_str(), matrizPontos, tipo);
  superficie->SetCor(ColorDialog->Color);
  sistemaGrafico->InsereSuperficie(superficie);
  Gerente->Itens->AddItem(s, NULL);  
}
//---------------------------------------------------------------------------
void TIncluirObjeto::CriaNovaCurva(bool &OK)
{
  AnsiString s;
  if (!pontosCurva){
    MessageBox(Handle,"Adicione os pontos antes","ATENO",MB_OK);
    return;
  }
  s += "Curva: ";
  tipoCurva tipo= BEZIER;
  if (Hermite->Checked) tipo = HERMITE;
  else if (Spline->Checked) tipo = SPLINE;
  int x;
  switch(tipo){
    case BEZIER:
      if (! (pontosCurva->size()>3 && !( (pontosCurva->size()-4)%3 ) ) ){
        MessageBox(Handle,"Curvas de Bezier precisam de 4 + 3*n pontos","ATENO",MB_OK);
        OK = false;
      }
    break;
    case HERMITE:
      if ( !(pontosCurva->size()>3 && !((pontosCurva->size()-4)%2) ) ){
        OK = false;
        MessageBox(Handle,"Curvas de Hermite precisam de 4 + 2*n valores","ATENO",MB_OK);
      }
    break;
    case SPLINE:
      if (pontosCurva->size()<4) {
        MessageBox(Handle,"Curvas Spline precisam de 4 ou mais pontos","ATENO",MB_OK);
        OK = false;
      }
    break;
  }
  if (OK) {
    s += NomeObjeto->Text.c_str();
    Curva* curva = new Curva(s.c_str(),tipo);
    curva->SetPontos(pontosCurva);
    curva->SetCor(ColorDialog->Color);
    sistemaGrafico->InsereCurva(curva);
    Gerente->Itens->AddItem(s, NULL);
  }
}
//---------------------------------------------------------------------------
void TIncluirObjeto::ValidaEntradaEdit(TEdit* edit)
{
  DecimalSeparator = '.';
  try{
    edit->Text.ToDouble();
  }catch(EConvertError& e){
    MessageBox(Handle,"Digite apenas valores reais - Ex: 150.25","ATENO",MB_OK);
    edit->Text = "0";
    ActiveControl = edit;
  }

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::XPontoExit(TObject *Sender)
{
  ValidaEntradaEdit(dynamic_cast<TEdit*>(Sender));
}
//---------------------------------------------------------------------------
void TIncluirObjeto::CriaNovoObjetoTriangularizado(bool& OK)
{
  if(!vetorTriangulos) {
    MessageBox(Handle,"Entre com pelo menos um triangulo","ATENO",MB_OK);
    OK=false;
    return;
  }
  OK=true;
  ObjetoTriangularizado* obj = new ObjetoTriangularizado(
    " ", ColorDialogAmbiente->Color, ColorDialogDifusa->Color,
    ColorDialogEspecular->Color, atof(Polimento->Text.c_str()),
    vetorTriangulos);
  obj->SetCor(ColorDialog->Color);

  sistemaGrafico->AdicionaObjetoTriangularizado(obj);
  Gerente->Itens->AddItem( AnsiString("Objeto Tiangularizado: ")+NomeObjeto->Text.c_str(), NULL);
}
//---------------------------------------------------------------------------
void __fastcall TIncluirObjeto::AdicionaTrianguloButtonClick(
      TObject *Sender)
{
  Ponto* p1 = new Ponto("p1", atof(X1Triangulo->Text.c_str()),atof(Y1Triangulo->Text.c_str()),atof(Z1Triangulo->Text.c_str()));
  Ponto* p2 = new Ponto("p1", atof(X2Triangulo->Text.c_str()),atof(Y2Triangulo->Text.c_str()),atof(Z2Triangulo->Text.c_str()));
  Ponto* p3 = new Ponto("p1", atof(X3Triangulo->Text.c_str()),atof(Y3Triangulo->Text.c_str()),atof(Z3Triangulo->Text.c_str()));
  Ponto* vetor = new Ponto("p1", atof(VetorXTriangulo->Text.c_str()),atof(VetorYTriangulo->Text.c_str()),atof(VetorZTriangulo->Text.c_str()));
  Triangulo* triangulo = new Triangulo("", p1, p2, p3, vetor);
  if (!vetorTriangulos)
    vetorTriangulos = new vector<Triangulo*>;
  vetorTriangulos->push_back(triangulo);
  AnsiString nome = "("+X1Triangulo->Text+","+Y1Triangulo->Text+","+Z1Triangulo->Text + ")"
   +"-"+ "("+X2Triangulo->Text+","+Y2Triangulo->Text+","+Z2Triangulo->Text + ")"
   +"-"+ "("+X3Triangulo->Text+","+Y3Triangulo->Text+","+Z3Triangulo->Text + ")";

  ListBoxTriangulos->Items->Add(nome);

  X1Triangulo->Text = "0";
  X2Triangulo->Text = "0";
  X3Triangulo->Text = "0";
  Y1Triangulo->Text = "0";
  Y2Triangulo->Text = "0";
  Y3Triangulo->Text = "0";
  Z1Triangulo->Text = "0";
  Z2Triangulo->Text = "0";
  Z3Triangulo->Text = "0";

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::ReflDifusaButtonClick(TObject *Sender)
{
  ColorDialogDifusa->Execute();
  PaintBoxCorDifusa->Canvas->Brush->Color = ColorDialogDifusa->Color;
  PaintBoxCorDifusa->Canvas->FillRect(TRect(0,0,PaintBoxCorDifusa->Width,PaintBoxCorDifusa->Height));

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::ReflAmbienteButtonClick(TObject *Sender)
{
  ColorDialogAmbiente->Execute();
  PaintBoxCorAmbiente->Canvas->Brush->Color = ColorDialogAmbiente->Color;
  PaintBoxCorAmbiente->Canvas->FillRect(TRect(0,0,PaintBoxCorAmbiente->Width,PaintBoxCorAmbiente->Height));

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::ReflEspecularButtonClick(TObject *Sender)
{
  ColorDialogEspecular->Execute();
  PaintBoxCorEspecular->Canvas->Brush->Color = ColorDialogEspecular->Color;
  PaintBoxCorEspecular->Canvas->FillRect(TRect(0,0,PaintBoxCorEspecular->Width,PaintBoxCorEspecular->Height));

}
//---------------------------------------------------------------------------

void __fastcall TIncluirObjeto::PageControl1Change(TObject *Sender)
{
  Paint();        
}
//---------------------------------------------------------------------------

