//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UTrans.h"
#include "UGer.h"
#include "USisGrafico.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTransformacao *Transformacao;
//---------------------------------------------------------------------------
__fastcall TTransformacao::TTransformacao(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTransformacao::cancelarClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TTransformacao::aplicar_transformClick(TObject *Sender)
{
  float* translacao = NULL;
  if(ativa_trans->Checked == true) {
    translacao = new float[3];
    translacao[0] = atof(ponto_x->Text.c_str());
    translacao[1] = atof(ponto_y->Text.c_str());
    translacao[2] = atof(ponto_z->Text.c_str());
  }

  float* escalonamento = NULL;
  if (ativa_esc->Checked == true) {
    escalonamento = new float[3];
    escalonamento[0] = atof(escala_x->Text.c_str());
    escalonamento[1] = atof(escala_y->Text.c_str());
    escalonamento[2] = atof(escala_z->Text.c_str());
  }

  float* rotacao = NULL;
  if (ativa_rot->Checked == true){
    rotacao = new float[3];
    rotacao[0] = atof(angulo_x->Text.c_str());
    rotacao[1] = atof(angulo_y->Text.c_str());
    rotacao[2] = atof(angulo_z->Text.c_str());
  }
  int selecionado = Gerente->Itens->ItemIndex;
  Gerente->GetSistemaGrafico()->AplicaTransformacao(translacao,escalonamento,rotacao,selecionado);
  delete[] translacao;
  delete[] escalonamento;
  delete[] rotacao;

  Close();
}
//---------------------------------------------------------------------------
void __fastcall TTransformacao::ativa_transClick(TObject *Sender)
{
  VerificaBotaoAplicar();        
}
//---------------------------------------------------------------------------

void __fastcall TTransformacao::ativa_escClick(TObject *Sender)
{
  VerificaBotaoAplicar();        
}
//---------------------------------------------------------------------------

void __fastcall TTransformacao::ativa_rotClick(TObject *Sender)
{
  VerificaBotaoAplicar();
}
//---------------------------------------------------------------------------
void TTransformacao::VerificaBotaoAplicar()
{
  if(ativa_trans->Checked || ativa_esc->Checked || ativa_rot->Checked)
    aplicar_transform->Enabled = true;
  else
    aplicar_transform->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTransformacao::FormShow(TObject *Sender)
{
  aplicar_transform->Enabled = false;
  ativa_esc->Checked = false;
  ativa_trans->Checked = false;
  ativa_rot->Checked = false;
  ponto_x->Text = "0";
  ponto_y->Text = "0";
  ponto_z->Text = "0";
  escala_x->Text = "1";
  escala_y->Text = "1";
  escala_z->Text = "1";
  angulo_x->Text = "0";
  angulo_y->Text = "0";
  angulo_z->Text = "0";

}
//---------------------------------------------------------------------------

void __fastcall TTransformacao::ponto_xExit(TObject *Sender)
{
  TEdit* edit = dynamic_cast<TEdit*>(Sender);
  DecimalSeparator = '.';
  try{
    edit->Text.ToDouble();
  }catch(EConvertError& e){
    MessageBox(Handle,"Digite apenas valores reais - Ex: 150.25","ATENO",MB_OK);
    edit->Text = "0";
    ActiveControl = edit;
  }
}
//---------------------------------------------------------------------------

