#ifndef WindowH
#define WindowH

#include "WireFrame.h"

class Window : public WireFrame
{
   public:
     Window( float xWMin, float xWMax, float yWMin, float yWMax);
     Window(Ponto* p1, Ponto* p2, Ponto* p3, Ponto* p4);
     float GetXMinWindow();
     float GetXMaxWindow();
     float GetYMinWindow();
     float GetYMaxWindow();
     void SetXMinWindow(float valor);
     void SetXMaxWindow(float valor);
     void SetYMinWindow(float valor);
     void SetYMaxWindow(float valor);
     void SetVPN(Ponto* VPN);
     bool ZoomIn(float passo);
     bool ZoomOut(float passo);
     void Mover(float passo, int d);
     float GetAngulo();
     float GetAnguloX();
     float GetAnguloY();
     float GetAnguloZ();
     void SetAngulo(float _angulo);
     void SetAnguloX(float _anguloX);
     void SetAnguloY(float _anguloY);
     void SetAnguloZ(float _anguloZ);
     Ponto& GetCOP();
     void AplicaTransformacao(Matriz* matrizDeTransformacao, bool CPP);
     void AplicaTransformacao(float* translacao, float* escalonamento, float* rotacao,bool CPP);
     float GetDistanciaCOP(){return distanciaCOP;}

   private:
     Ponto *p1, *p2, *p3, *p4, *COP, *VPN;
     float angulo, anguloX, anguloY, anguloZ;
     float minimo, maximo;
     float distanciaCOP;
};

enum Direcao{
  DIREITA,
  ESQUERDA,
  CIMA,
  BAIXO,
  FRENTE,
  TRAZ
};
//---------------------------------------------------------------------------
#endif
